import { ICalendarsRepository } from "@modules/calendar/repositories/ICalendarsRepository";
import { AppError } from "@shared/error/AppError";
import { inject, injectable } from "tsyringe";

@injectable()
class DeleteCalendarUseCase {
    constructor(
        @inject('CalendarsRepository')
        private calendarsRepository: ICalendarsRepository
    ) {}

    async execute(id: string) {
        const calendarAlreadyExists = await this.calendarsRepository.findById(id)
        if(!calendarAlreadyExists) {
            throw new AppError('Calendar doesnt Exists', 400)
        }
        await this.calendarsRepository.deleteCalendar(id)

        return true
    }
}

export {DeleteCalendarUseCase}